public with sharing class TestManageSender {
    
    public void testManageSender(){
        OneSpanAPIObjects.Sender sender = new OneSpanAPIObjects.Sender();
        sender.email = 'john.smith@mailinator.com';
        sender.firstName = 'John';
        sender.lastName = 'Smith';
        sender.status = OneSpanAPIObjects.SenderStatus.INVITED; //OneSpanAPIObjects.SenderStatus.ACTIVE
        sender.language = 'EN';
        sender.company = 'OSS';
        inviteSender(sender);
    }
    
  
  
    
    public void inviteSender(OneSpanAPIObjects.Sender sender){
        String resourceUrl = '/account/senders';
        String requestPayload = JSON.serialize(sender);
        HttpResponse response = doPost(resourceUrl, requestPayload);
        
        // Check response
        if(response.getStatusCode() != 200)
        {
            throw new OneSpanRESTAPIHelper.OneSpanRestAPIHelperException('Error invite sender. ' + response.getStatusCode() + ' - ' + response.getStatus() + ' - ' +  response.getBody());
        }
    }
    
    private HttpResponse doPost(String resourceUrl, String requestBody)
    {
        OneSpan_Connection_Settings__c connectionSettings = OneSpan_Connection_Settings__c.getInstance('Main');    
        //Cleanup requestBody string before sending it out
        String outboundRequestBody = OneSpanJSONHelper.prepareOutboundJSON(requestBody);
        System.debug('=> outboundRequestBody:'+outboundRequestBody);

        // Build Request
        HttpRequest request = new HttpRequest();

        request.setEndpoint(connectionSettings.Endpoint__c + resourceUrl);
        request.setBody(outboundRequestBody);
        request.setMethod('POST');
        request.setHeader('Authorization', 'Basic ' + connectionSettings.API_Key__c);
        request.setHeader('Content-type', 'application/json');
        request.setHeader('Accept', 'application/json');

        // Send Request
        HttpResponse response = (new Http()).send(request);

        return response;
    }
    
  
  
    
    
    
    
}